static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0x94, 0xA1, 0xF8, 0xA3, 0x6E, 0xA5, 0xFC, 0x0C, 0x2A, 0xD2,
        0xFE, 0x41, 0xA9, 0x48, 0xCA, 0x55, 0xAA, 0x2A, 0x61, 0xEF,
        0x73, 0xC4, 0xD3, 0x74, 0x46, 0x68, 0xE1, 0x48, 0xBA, 0x22,
        0xFC, 0x9C, 0x4E, 0x42, 0x9E, 0x47, 0x2C, 0xE7, 0xB0, 0x1F,
        0xFB, 0x68, 0x63, 0x2E, 0x25, 0x6F, 0xE7, 0xE5, 0xF7, 0x76,
        0x99, 0xAC, 0x0E, 0xE3, 0x99, 0xC3, 0x8A, 0x4C, 0x99, 0xFE,
        0x6F, 0x01, 0x14, 0xAF
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
